/*
 * Copyright 2013 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.nau;

import at.jku.risc.stout.nau.data.NodeFactory;
import at.jku.risc.stout.nau.data.atom.Atom;
import at.jku.risc.stout.nau.data.atom.FunctionSymbol;

/**
 * Some test cases
 * 
 * @author Alexander Baumgartner
 */
public class TestFactory {

	public static void main(String[] args) {
		try {
			test();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public static void test() throws Exception {
		NodeFactory factory = new NodeFactory();
		Object a1 = factory.newFunction("a", null, "d1");
		factory.newAtom("a");
		factory.newAtom("b");
		factory.newAtom("b");
		factory.newAtom("a", "s1");
		Object a2 = factory.newFunction("a");
		factory.newAtom("a", "s1");
		System.out.println(factory.getAllByType(Atom.class));
		System.out.println(factory.getAllByType(FunctionSymbol.class));
		System.out.println(factory.getAllByType(String.class));
		System.out.println(a1 == a2);
		System.out.println(a1.hashCode() == a2.hashCode());
		System.out.println(a1.equals(a2));
	}
}
